import cv2
import torch
import torchvision
import torchvision.transforms as transforms

coco_names = [
    '__background__', 'person', 'bicycle', 'car', 'motorcycle', 'airplane', 'bus',
    'train', 'truck', 'boat', 'traffic light', 'fire hydrant', 'N/A', 'stop sign',
    'parking meter', 'bench', 'bird', 'cat', 'dog', 'horse', 'sheep', 'cow',
    'elephant', 'bear', 'zebra', 'giraffe', 'N/A', 'backpack', 'umbrella', 'N/A', 'N/A',
    'handbag', 'tie', 'suitcase', 'frisbee', 'skis', 'snowboard', 'sports ball',
    'kite', 'baseball bat', 'baseball glove', 'skateboard', 'surfboard', 'tennis racket',
    'bottle', 'N/A', 'wine glass', 'cup', 'fork', 'knife', 'spoon', 'bowl',
    'banana', 'apple', 'sandwich', 'orange', 'broccoli', 'carrot', 'hot dog', 'pizza',
    'donut', 'cake', 'chair', 'couch', 'potted plant', 'bed', 'N/A', 'dining table',
    'N/A', 'N/A', 'toilet', 'N/A', 'tv', 'laptop', 'mouse', 'remote', 'keyboard', 'cell phone',
    'microwave', 'oven', 'toaster', 'sink', 'refrigerator', 'N/A', 'book',
    'clock', 'vase', 'scissors', 'teddy bear', 'hair drier', 'toothbrush'
]

cv2.namedWindow("result", 0)
one_img = cv2.imread("test1.jpg")
one_img = cv2.cvtColor(one_img, cv2.COLOR_BGR2RGB)
model = torchvision.models.detection.fasterrcnn_mobilenet_v3_large_320_fpn(pretrained=True)
device = torch.device('cuda' if torch.cuda.is_available() else 'cpu')
# self.device = "cpu"
model.eval().to(device)
print("device", device)
print("model", model)
transformRCNN = transforms.Compose([
    transforms.ToTensor()
])
tensor = transformRCNN(one_img)
print(tensor.shape)
#add batch size
tensor = tensor.unsqueeze(0)
outputsRCNN = model(tensor)
pred_classes = [coco_names[i] for i in outputsRCNN[0]['labels'].cpu().numpy()]
pred_scores = outputsRCNN[0]['scores'].detach().cpu().numpy()
pred_bboxes = outputsRCNN[0]['boxes'].detach().cpu().numpy()

print("pred_bboxes", pred_bboxes)
print("pred_scores", pred_scores)
print("pred_classes", pred_classes)

cv2.imshow("result", one_img)
cv2.waitKey()
